# XLSW-3DP-Ultrasonic-300K

## 传感器数据传输与样式

- USART
  - baudrate 115200
  - 8N1

- 数据格式
```cap_val:183	Distance: 7361	Temp:2735```
  - cap_val:183	      超声死区外的ToF数据
  - Distance: 7361	  距离数据，100倍mm距离值
  - Temp:2735         温度数据，100倍摄氏度值

## 供电与数据

本项目支持12V/24V供电，默认编译选项为12V供电。主要相关部分为超声的驱动部分。
主要校准数据也会以12V为主。如果需要24V供电，请自行修改编译选项。


## 条件编译与输出

- 条件编译共有两个地方需要修改：
  1. `ProjectDir/inc/ultrasonic_driver.h` 中配置12V/24V供电，默认为12V供电。
     `#define POWER_SUPPLY_12V`
  2. `ProjectDir/CMakeLists.txt` 中配置编译选项，默认为12V供电。
     `set(POWER_VOLTAGE "12V")`

- 输出文件命名：
`XLSW_US-IR_FW_12V_V0.0.13_2024-x-x.bin/hex` 
  1. XLSW_US-IR_FW: 表示该项目为300K模拟超声波测距与IR非接触式测温方案的MCU固件
  2. 12V: 表示目前编译固件为12V供电情况下优化的校正参数，建议与实际对应，这样可以获得更好的测距准确度
  3. 2024-x-x: 表示编译日期




## TODO List

### 超声

- [x] 超声驱动信号（300KHz 50%duty 5cycles）发送
- [x] PA2/PA3配置为USART0
- [x] LED配置存活状态闪烁
- [x] 超声反射回波接受与精准计时

- 超声波反射回来后到sensor成功接收，GPIO上的反应主要分为两部分，
    1. 超声波在发送时产生的余震，24V下大概为230us，12V下大概为210us。（前面所说的时间均为比较保守的时间）
    2. 超声波会在接触到目标后反射回sensor上，并产生一个低电平，主要就是检测这部分。
  
- [x] 产生一个210-230us可调节的准确延时。（TIMER15配置为1us计一个数，设置重载为需要的时间，产生中断即可。）
- [x] 在产生指定时间的中断服务函数中，开启EXTI0（PA0,sensor信号接收引脚），开启TIMER14（计时计数器，1us计一个数，计算接收到外部中断的时间）
- [ ] 在外部中断服务函数中，产生一个事件或中断，进入到TIMER14的中断
- [x] TIMER14不存在F4x系列，改用TIMER16.
- [x] 放弃上述流程，多一层中断层，直接在EXTI0的中断服务函数中，直接读取TIMER16的CH_0计数值。

### IR

- [x] 配置IIC接口到PF0/1
- [x] 移植读取目标温度的函数
- [ ] 设置不同反射率下的校准
- [ ] 读取环境温度

### 条件编译

- [ ] 自动判断某一个条件编译是否开启，并在CmakeList中添加对应选项，输出文件时加以标识